﻿namespace UltraGridKeysEvents
{
    using System;
    using System.Data;
    using System.Diagnostics;
    using System.Windows.Forms;

    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        private int rows;
        private int cols;

        public Form1()
        {
            this.InitializeComponent();
            this.rows = 10;
            this.cols = 5;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.SetDataBinding(this.GetData(this.rows, this.cols), null);
            this.ultraGrid1.DisplayLayout.Override.CellClickAction = CellClickAction.RowSelect;
            this.comboBox1.SelectedIndex = 0;
        }

        private void Button1_Click(object sender, EventArgs e)
        {
            string actionType = this.comboBox1.Text;
            switch (actionType)
            {
                case "UltraGrid.Select":
                    this.ultraGrid1.Select();
                    break;
                case "UltraGrid.Focus":
                    this.ultraGrid1.Focus();
                    break;
                case "UltraGrid.PerformAction":
                    // this action will fail if there is no active row or if there is active cell already - this is by design
                    this.ultraGrid1.PerformAction(UltraGridAction.ActivateCell);
                    break;
                case "UltraGrid.ActiveRow":
                    this.ultraGrid1.ActiveRow = this.ultraGrid1.Rows[0];
                    this.ultraGrid1.Selected.Rows.Clear();
                    this.ultraGrid1.Selected.Rows.Add(this.ultraGrid1.ActiveRow);
                    break;
                default:
                    break;
            }
        }

        private void UltraGrid1_KeyPress(object sender, KeyPressEventArgs e)
        {
            Debug.WriteLine("Key Press fired");
        }

        private void UltraGrid1_KeyDown(object sender, KeyEventArgs e)
        {
            Debug.WriteLine("Key Down fired");
        }

        private object GetData(int rows, int cols)
        {
            DataTable dt = new DataTable();

            for (int col = 0; col < cols; col++)
            {
                dt.Columns.Add(string.Format("Column #{0}", col + 1));
            }

            for (int row = 0; row < rows; row++)
            {
                DataRow addRow = dt.NewRow();
                foreach (DataColumn column in dt.Columns)
                {
                    addRow[column] = string.Format("{0}.{1}", row + 1, column.Ordinal + 1);
                }

                dt.Rows.Add(addRow);
            }

            return dt;
        }
    }
}
